<template>
	<xn-form-container
		:title="formData.id ? '编辑车辆信息' : '增加车辆信息'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :wrapper-col="wrapperCol" :label-col="labelCol">
			<a-form-item label="车牌号：" name="licensePlate">
				<a-input v-model:value="formData.licensePlate" placeholder="请输入车牌号" allow-clear />
			</a-form-item>
			<a-form-item label="车辆轴数：" name="vehicleAxles">
				<a-select v-model:value="formData.vehicleAxles" placeholder="请选择车辆轴数"
						  :options="overIdList"
				> </a-select>
			</a-form-item>
			<a-form-item label="司机姓名：" name="driverName">
				<a-input v-model:value="formData.driverName" placeholder="请输入司机姓名" allow-clear />
			</a-form-item>
			<a-form-item label="司机电话：" name="driverMobile">
				<a-input v-model:value="formData.driverMobile" placeholder="请输入司机电话" allow-clear />
			</a-form-item>
			<a-form-item label="是否启用：" name="status" v-if="formData.id!=null && formData.id!=''">
				<a-radio-group button-style="solid" v-model:value="formData.status">
					<a-radio-button value="1">
						启用
					</a-radio-button>
					<a-radio-button value="2">
						关闭
					</a-radio-button>
				</a-radio-group>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="bizVehicleForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import bizVehicleApi from '@/api/biz/bizVehicleApi'
	import bizExcessConfigApi from "@/api/biz/bizExcessConfigApi";
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)
	const overIdList = ref()

	//设置表单样式
	const labelCol = ref({ span: 5})
	const wrapperCol = ref({ span: 16})

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}else{
			formData.value.status = '1'
		}
		//查询车辆轴数
		bizExcessConfigApi.getList().then((res)=>{
			overIdList.value = res.map((item)=>{
				return{
					value:item.id,
					label:item.vehicleAxleNumber+'轴'
				}
			})
		})
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		licensePlate: [required('请输入车牌号')],
		vehicleAxles: [required('请选择车辆轴数')],
		//driverName: [required('请输入司机姓名')],
		//driverMobile: [required('请输入司机电话')],
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				bizVehicleApi
					.bizVehicleSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
